## FsParticipant FsParticipant — A participant in a conference |

## Synopsis

    #include <gst/farsight/fs-conference-iface.h>

                        FsParticipant;
    struct              FsParticipantClass;
    #define             FS_PARTICIPANT_DATA_LOCK            (participant)
    #define             FS_PARTICIPANT_DATA_UNLOCK          (participant)

## Object Hierarchy

      GObject
       +----FsParticipant

## Properties

      "cname"                    gchar*                : Read / Write / Construct

## Signals

      "error"                                          : Run Last

## Description

This object is the base implementation of a Farsight Participant. It needs to be derived and implemented by a farsight conference gstreamer element. A participant represents any source of media in a conference. This could be a human-participant or an automaton.

## Details

### FsParticipant

    typedef struct _FsParticipant FsParticipant;

All members are private (access them using the properties)

### struct FsParticipantClass

    struct FsParticipantClass {
      GObjectClass parent_class;

      /* virtual functions */
    };

The FsParticipant class has no virtual methods to implement, but you may want to override the properties or attach more date to it

GObjectClass `parent_class`; | Our parent

### FS_PARTICIPANT_DATA_LOCK()

    #define             FS_PARTICIPANT_DATA_LOCK(participant)

Locks the participant for data set with `g_object_set_data()` or `g_object_set_qdata()`.

`participant` : | A FsParticipant

### FS_PARTICIPANT_DATA_UNLOCK()

    #define             FS_PARTICIPANT_DATA_UNLOCK(participant)

Unlocks the participant for data set with `g_object_set_data()` or `g_object_set_qdata()`.

`participant` : | A FsParticipant

## Property Details

### The `"cname"` property

      "cname"                    gchar*                : Read / Write / Construct

A string representing the cname of the current participant. User must free the string after getting it.

Default value: NULL

## Signal Details

### The `"error"` signal

    void                user_function                      (FsParticipant *self,
                                                            GObject       *object,
                                                            FsError        errorno,
                                                            gchar         *error_msg,
                                                            gchar         *dbg_msg,
                                                            gpointer       user_data)      : Run Last

This signal is emitted in any error condition

`self` : | FsParticipant that emitted the signal
`object` : | The Gobject that emitted the signal
`errorno` : | The number of the error
`error_msg` : | Error message to be displayed to user
`dbg_msg` : | Debugging error message
`user_data` : | user data set when the signal handler was connected.